clear all; 
close all;
clc;

%Open the connection to the processor
cbmex('open');

%Tell CBMEX to begin collecting data (1)
cbmex('trialconfig',1);

%Make sure buffer is cleared before beginning our test
cbmex('trialdata',1);

%Setup the condition for our loop
Triggered = 0;

while Triggered == 0
    pause(0.25)
    %Tell CBMEX to get the data currently in the buffer. Outputs are named
    %according to the data types they hold
    [event, time, continuous] = cbmex('trialdata',1);
    
    %Find the number of spikes in our 0.25 s buffer on channel 1
    NumberOfSpikes = length(event{1,2});
    
    %Tell the user the number of spikes by writing to command window
    disp(strcat(num2str(NumberOfSpikes),' Spikes'));
    
    %Trigger an output if number of spikes > Threshold
    if NumberOfSpikes > 10
        disp('Triggered!');
        Triggered = 1;
        break
    end
    
end
        


cbmex('close')